import { _WidgetBaseConstructor } from "./_WidgetBase";

interface _WidgetsInTemplateMixin {
    /**
     * Used to provide a context require to dojo/parser in order to be
     * able to use relative MIDs (e.g. `./Widget`) in the widget's template.
     */
    contextRequire: Function;

    startup(): void;
}

declare module "dojo/_base/kernel" {
    interface Dijit {
        _WidgetsInTemplateMixin: _WidgetsInTemplateMixinConstructor
    }
}

type _WidgetsInTemplateMixinConstructor = _WidgetBaseConstructor<_WidgetsInTemplateMixin>;
declare const _WidgetsInTemplateMixin: _WidgetsInTemplateMixinConstructor;
export = _WidgetsInTemplateMixin;
